"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LayerMaster = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const AbsoluteFill_1 = require("./AbsoluteFill");
const get_environment_1 = require("./get-environment");
const LayerMaster = ({ layers, defaultProps, inputProps, fallbackComponent: FallbackComponent, }) => {
    return (
    // TODO: Same styles as normal
    (0, jsx_runtime_1.jsx)(AbsoluteFill_1.AbsoluteFill, { children: layers.map((layer, i) => {
            const Comp = layer.component;
            if (layer.type === 'web') {
                if (FallbackComponent === null) {
                    // eslint-disable-next-line react/no-array-index-key
                    return (0, jsx_runtime_1.jsx)(Comp, { ...defaultProps, ...inputProps }, String(i));
                }
                return (
                // eslint-disable-next-line react/no-array-index-key
                (0, jsx_runtime_1.jsx)(react_1.Suspense, { fallback: (0, jsx_runtime_1.jsx)(FallbackComponent, {}), children: (0, jsx_runtime_1.jsx)(Comp, { ...defaultProps, ...inputProps }) }, String(i)));
            }
            // SVG should not support suspense
            if (layer.type === 'svg') {
                if ((0, get_environment_1.getRemotionEnvironment)() === 'rendering') {
                    return null;
                }
                return ((0, jsx_runtime_1.jsx)(AbsoluteFill_1.AbsoluteFill, { children: (0, jsx_runtime_1.jsx)(Comp, { ...defaultProps, ...inputProps }, String(i)) }));
            }
            if (layer.type === 'video') {
                if ((0, get_environment_1.getRemotionEnvironment)() === 'rendering') {
                    return null;
                }
                // TODO: AbsoluteFill is different flex direction
                return ((0, jsx_runtime_1.jsx)(AbsoluteFill_1.AbsoluteFill, { children: (0, jsx_runtime_1.jsx)(Comp, { ...defaultProps, ...inputProps }, String(i)) }));
            }
            throw new Error('Unknown layer type');
        }) }));
};
exports.LayerMaster = LayerMaster;
