"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SatoriForDevelopment = exports.SatoriForRendering = exports.Satori = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importStar(require("react"));
const satori_1 = __importDefault(require("satori"));
const _1 = require(".");
const get_environment_1 = require("./get-environment");
const NativeLayers_1 = require("./NativeLayers");
const use_video_config_1 = require("./use-video-config");
const Satori = ({ children }) => {
    if ((0, get_environment_1.getRemotionEnvironment)() === 'rendering') {
        return (0, jsx_runtime_1.jsx)(exports.SatoriForRendering, { children: children });
    }
    return (0, jsx_runtime_1.jsx)(exports.SatoriForDevelopment, { children: children });
};
exports.Satori = Satori;
const SatoriForRendering = ({ children }) => {
    const { width, height } = (0, use_video_config_1.useVideoConfig)();
    const { setSatoriStack } = (0, react_1.useContext)(NativeLayers_1.NativeLayersContext);
    (0, react_1.useLayoutEffect)(() => {
        const handle = (0, _1.delayRender)();
        (0, satori_1.default)(children, {
            width,
            height,
            fonts: [],
        })
            .then((svg) => {
            (0, _1.continueRender)(handle);
            setSatoriStack(svg);
            console.log({ svg });
        })
            .catch((err) => {
            console.log(err);
        });
    }, [children, height, setSatoriStack, width]);
    return (0, jsx_runtime_1.jsx)(_1.Experimental.Null, {});
};
exports.SatoriForRendering = SatoriForRendering;
const SatoriForDevelopment = ({ children, }) => {
    const [markup, setMarkup] = react_1.default.useState(null);
    const { width, height } = (0, use_video_config_1.useVideoConfig)();
    (0, react_1.useEffect)(() => {
        (0, satori_1.default)(children, {
            width,
            height,
            fonts: [],
        })
            .then((svg) => {
            setMarkup(svg);
            console.log({ svg });
        })
            .catch((err) => {
            console.log(err);
        });
    }, [children, height, width]);
    if (!markup) {
        return null;
    }
    return ((0, jsx_runtime_1.jsx)("div", { 
        // eslint-disable-next-line react/no-danger
        dangerouslySetInnerHTML: {
            __html: markup,
        } }));
};
exports.SatoriForDevelopment = SatoriForDevelopment;
