export declare const getStaticFiles: () => StaticFile[];
export declare type StaticFile = {
    /**
     * A string that you can pass to the `src` attribute of an `<Audio>`, `<Img>` and `<Video>` element.
     */
    src: string;
    /**
     * The filepath of the file, relative to the public folder.
     * Example: `subfolder/image.png`
     */
    name: string;
    sizeInBytes: number;
    /**
     * UNIX timestamp in milliseconds
     */
    lastModified: number;
};
