import type { ComponentType, LazyExoticComponent } from 'react';
import React from 'react';
export declare type LooseComponentType<T> = ComponentType<T> | ((props: T) => React.ReactNode);
export declare type InputLayer<T> = {
    component: LooseComponentType<T>;
    type: 'web' | 'svg' | 'video';
};
export declare type CompProps<T> = {
    lazyComponent: () => Promise<{
        default: LooseComponentType<T>;
    }>;
} | {
    component: LooseComponentType<T>;
} | {
    layers: InputLayer<T>[];
};
export declare type Layer<T> = {
    component: LazyExoticComponent<ComponentType<T>>;
    type: 'web' | 'svg' | 'video';
};
export declare type SmallLayer = Pick<Layer<unknown>, 'type'>;
export declare const convertComponentTypesToLayers: <T>(compProps: CompProps<T>) => Layer<T>[];
export declare const convertComponentTypesToLayersWithCache: <T>(compProps: CompProps<T>, prevCompProps: CompProps<T> | null, prevReturnValue: Layer<T>[] | null) => Layer<T>[];
export declare const useLayers: <T>(compProps: CompProps<T>) => Layer<T>[];
